#!/usr/bin/env python
import os, sys
from optparse import OptionParser

class Submission:

    def __init__(self, library_list, project_dir, config, starting_lib, lib_num, cluster_head, cid_memory, transcript, transcript_seq, read_length, host_name, queue):
	self.lib_list = library_list
	lib_list_handle = open(self.lib_list, 'r')
	line = lib_list_handle.next()
	line = line[:-1]
	lib_list_handle.close()
	#self.lib = lib
	self.project_dir = project_dir
	self.config = config
	self.assembly_ver = line.split(',')[1]
	self.cluster_head = cluster_head
	self.barnacle_ver = line.split(',')[2] 
	self.memory = cid_memory
	self.start_lib = starting_lib
	self.lib_num = int(lib_num)
	self.transcript = transcript
	self.transcript_seq = transcript_seq
	self.read_length = read_length
	self.host_name = host_name
	self.queue = queue

    def _process_libs(self, count, library):
        library_path = self.project_dir + '/'
        config_file = self.config
        assembly_version = self.assembly_ver
        cluster = self.cluster_head
        barnacle_version = self.barnacle_ver

       	while ((count < self.lib_num) or (count == self.lib_num)):
            library_dir = library_path + library
            cmd = 'time perl %s -lib %s -lib_dir %s -config %s -identify_candidates -assembly_ver abyss-%s -cluster %s -ver %s' %(p, library, library_dir, config_file, assembly_version, cluster, barnacle_version)
            print cmd
            #os.system(cmd)
            #count = count + 1
            try:
                line = lib_list_handle.next()
                library = line[:-1]
                count = count + 1

            except StopIteration:
                print "end of the library list"
                break

    def identify_candidates(self):
	lib_list_handle = open(self.lib_list, 'r')
	p = '/projects/transabyss/Barnacle/v1.1.0/barnacle.pl'
	library_path = self.project_dir + '/'
	config_file = self.config
	assembly_version = self.assembly_ver
	cluster = self.cluster_head
	barnacle_version = self.barnacle_ver
	count = 0
	for linenum, line in enumerate(lib_list_handle):
	    #print line
	    library = line[:-1].split(',')[0]
	    if (library == self.start_lib):
		count = count + 1
	    	while ((count < self.lib_num) or (count == self.lib_num)):
	            library_dir = library_path + library 
	            cmd = 'time perl %s -lib %s -lib_dir %s -config %s -identify_candidates -r2c_no_short_ctgs -assembly_ver %s -cluster %s -ver %s -cid_memory %s -read_length %s -hostname %s -queue %s' %(p, library, library_dir, config_file, assembly_version, cluster, barnacle_version, self.memory, self.read_length, self.host_name, self.queue)
	            print cmd
	            os.system(cmd)
		    try:
		        line = lib_list_handle.next()
		        library = line[:-1].split(',')[0]
			count = count + 1
			
		    except StopIteration:
			print "end of the library list"
			break

    def check_status_cid(self):
	lib_list_handle = open(self.lib_list, 'r')
	p = '/projects/transabyss/Barnacle/v1.1.0/alignment_processing/check_status.py'
	library_path = self.project_dir + '/'
	cluster_path = '/Assembly/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/cluster_cid'
	count = 0
	for linenum, line in enumerate(lib_list_handle):
	    library = line[:-1].split(',')[0]
	    if (library == self.start_lib):
	        count = count + 1
		while ((count < self.lib_num) or (count == self.lib_num)):
	            path = library_path + library + cluster_path
	            cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s' %(p, path)
	            print cmd
	            os.system(cmd)
		    try:
		        line = lib_list_handle.next()
			library = line[:-1].split(',')[0]
			count = count + 1
		    except StopIteration:
			print "end of the library list"
			break
        
    def resubmit_cid(self):
        lib_list_handle = open(self.lib_list, 'r')
        p = '/projects/transabyss/Barnacle/v1.1.0/alignment_processing/check_status.py'
        library_path_pre = self.project_dir + '/'
        library_path_suf = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/cluster_cid'
        count = 0
        for linenum, line in enumerate(lib_list_handle):
            library = line[:-1].split(',')[0]
            if (library == self.start_lib):
                count = count + 1
                while ((count < self.lib_num) or (count == self.lib_num)):
                    path = library_path_pre + library + library_path_suf
                    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s --resubmit --cluster-head %s --memory %s --hostname %s' %(p, path, self.cluster_head, self.memory, self.host_name)
                    print cmd
                    os.system(cmd)
                    try:
                        line = lib_list_handle.next()
                        library = line[:-1].split(',')[0]
                        count = count + 1
                    except StopIteration:
                        print "end of the library list"
                        break

    def run_support(self):
	lib_list_handle = open(self.lib_list, 'r')
	p = '/projects/transabyss/Barnacle/v1.1.0/utils/submit.py'
	library_path = self.project_dir + '/'
	support_path = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/run_support.sh'
	count = 0
	for linenum, line in enumerate(lib_list_handle):
	    library = line[:-1].split(',')[0]
	    if (library == self.start_lib):
		count = count + 1
		while ((count < self.lib_num) or (count == self.lib_num)):
		    path = library_path + library + support_path
		    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s %s %s --memory %s --hostname %s' %(p, library, path, self.cluster_head, self.memory, self.host_name)
		    print cmd
		    os.system(cmd)
		    try:
		        line = lib_list_handle.next()
		        library = line[:-1].split(',')[0]
		        count = count + 1
		    except StopIteration:
			print "end of the library list"
			break

    def _create_barnacle_list(self, barnacle_list):
	lib_list_handle = open(self.lib_list, 'r')
	count = 0
	for linenum, line in enumerate(lib_list_handle):
	    library = line[:-1].split(',')[0]
	    if (library == self.start_lib):
		count = count + 1
		cmd = 'grep %s %s >%s' %(library, self.lib_list, barnacle_list)
		print cmd
		os.system(cmd)
		try:
		    line = lib_list_handle.next()
		    library = line[:-1].split(',')[0]
		except StopIteration:
		    print "end of the library list"
		    break
		while (count < self.lib_num):
		    cmd = 'grep %s %s >>%s' %(library, self.lib_list, barnacle_list)
		    print cmd
		    os.system(cmd)
		    try:
		        line = lib_list_handle.next()
			library = line[:-1].split(',')[0]
			count = count + 1
		    except StopIteration:
			print "end of the library list"
			break

    def check_support(self):
	lib_list_handle = open(self.lib_list, 'r')
	p = '/projects/transabyss/Barnacle/v1.1.0/grouping/check_support_status.py'
	
	lib_list = self.project_dir + '/barnacle_list.txt'
	self._create_barnacle_list(lib_list)

	cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s %s --check-cid --check-p2g --check-r2c' %(p, lib_list, self.project_dir)
	print cmd
	os.system(cmd)

    
    def check_p2g_support(self):
        lib_list_handle = open(self.lib_list, 'r')
        p = '/projects/transabyss/Barnacle/v1.1.0/support/pair_to_genome/check_status.py'
        library_path_pre = self.project_dir + '/'
        #library_path_suf = '/Assembly' + '/abyss-' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/cluster_p2g'
        library_path_suf = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/cluster_p2g'
	count = 0
        for linenum, line in enumerate(lib_list_handle):
            library = line[:-1].split(',')[0]
            if (library == self.start_lib):
                count = count + 1
                while ((count < self.lib_num) or (count == self.lib_num)):
                    path = library_path_pre + library + library_path_suf
                    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s' %(p, path)
                    print cmd
                    os.system(cmd)
                    try:
                        line = lib_list_handle.next()
                        library = line[:-1].split(',')[0]
                        count = count + 1
                    except StopIteration:
                        print "end of the library list"
                        break


    def integrate_p2g(self):
	lib_list_handle = open(self.lib_list, 'r')
	p = '/projects/transabyss/Barnacle/v1.1.0/support/pair_to_genome/integrate.py'
	library_path_pre = self.project_dir + '/' 
	library_path_suf = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/4_with_repeats/' 
	count = 0
	for linenum, line in enumerate(lib_list_handle):
	    library = line[:-1].split(',')[0]
	    if (library == self.start_lib):
		count = count + 1
		while ((count < self.lib_num) or (count == self.lib_num)):
		    path = library_path_pre + library + library_path_suf + library + '.barnacle.data' 
		    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s %s' %(p, library, path) 
		    print cmd
		    os.system(cmd)
		    try:
			line = lib_list_handle.next()
			library = line[:-1].split(',')[0]
			count = count + 1
		    except StopIteration:
			print "end of the library list"
			break

    def resubmit_p2g_support(self):
	lib_list_handle = open(self.lib_list, 'r')
        p = '/projects/transabyss/Barnacle/v1.1.0/support/pair_to_genome/check_status.py'
        library_path_pre = self.project_dir + '/'
        library_path_suf = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/cluster_p2g'
        count = 0
        for linenum, line in enumerate(lib_list_handle):
            library = line[:-1].split(',')[0]            
	    if (library == self.start_lib):
                count = count + 1
                while ((count < self.lib_num) or (count == self.lib_num)):
                    path = library_path_pre + library + library_path_suf
                    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s --resubmit --cluster-head %s --memory %s' %(p, path, self.cluster_head, self.memory)
                    print cmd
                    os.system(cmd)
                    try:
                        line = lib_list_handle.next()
                        library = line[:-1].split(',')[0]
                        count = count + 1
                    except StopIteration:
                        print "end of the library list"
                        break

    
    def check_r2c_support(self):
        lib_list_handle = open(self.lib_list, 'r')
        p = '/projects/transabyss/Barnacle/v1.1.0/support/read_to_contig/check_status.py'
        library_path_pre = self.project_dir + '/'
        library_path_suf = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/cluster_r2c'
        count = 0
        for linenum, line in enumerate(lib_list_handle):
            library = line[:-1].split(',')[0]
            if (library == self.start_lib):
                count = count + 1
                while ((count < self.lib_num) or (count == self.lib_num)):
                    path = library_path_pre + library + library_path_suf
                    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s' %(p, path)
                    print cmd
                    os.system(cmd)
                    try:
                        line = lib_list_handle.next()
                        library = line[:-1].split(',')[0]
                        count = count + 1
                    except StopIteration:
                        print "end of the library list"
                        break

    def resubmit_r2c_support(self):
        lib_list_handle = open(self.lib_list, 'r')
        p = '/projects/transabyss/Barnacle/v1.1.0/support/read_to_contig/check_status.py'
        library_path_pre = self.project_dir + '/'
        library_path_suf = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/cluster_r2c'
        count = 0
        for linenum, line in enumerate(lib_list_handle):
            library = line[:-1].split(',')[0]
            if (library == self.start_lib):
                count = count + 1
                while ((count < self.lib_num) or (count == self.lib_num)):
                    path = library_path_pre + library + library_path_suf
                    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s --resubmit --cluster-head %s --memory %s' %(p, path, self.cluster_head, self.memory)
                    print cmd
                    os.system(cmd)
                    try:
                        line = lib_list_handle.next()
                        library = line[:-1].split(',')[0]
                        count = count + 1
                    except StopIteration:
                        print "end of the library list"
                        break


    def integrate_r2c_support(self):
	lib_list_handle = open(self.lib_list, 'r')
	p = '/projects/transabyss/Barnacle/v1.1.0/support/read_to_contig/integrate.py'
	library_path_pre = self.project_dir + '/'
	library_path_suf = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/5_with_p2g'
	count = 0
	for linenum, line in enumerate(lib_list_handle):
	    library = line[:-1].split(',')[0]
	    if (library == self.start_lib):
		count = count + 1
                while ((count < self.lib_num) or (count == self.lib_num)):
                    path = library_path_pre + library + library_path_suf + '/' + library + '.barnacle.data'
                    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s %s' %(p, library, path)
                    print cmd
                    os.system(cmd)
                    try:
                        line = lib_list_handle.next()
                        library = line[:-1].split(',')[0]
                        count = count + 1
                    except StopIteration:
                        print "end of the library list"
                        break


    def filter_groups(self):
	lib_list_handle = open(self.lib_list, 'r')
	p = '/projects/transabyss/Barnacle/v1.1.0/filter/filter_groups.py'
        library_path_pre = self.project_dir + '/'
        library_path_suf = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/6_with_r2c'
        count = 0
        for linenum, line in enumerate(lib_list_handle):
            library = line[:-1].split(',')[0]
            if (library == self.start_lib):
                count = count + 1
                while ((count < self.lib_num) or (count == self.lib_num)):
                    path = library_path_pre + library + library_path_suf + '/' + library + '.barnacle.data'
                    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s --allow-repeats --ignore-topologies gap-nontandem-inverted_dupliction,gap-tandem-inverted_duplication,local-inversion' %(p, path)
                    print cmd
                    os.system(cmd)
                    try:
                        line = lib_list_handle.next()
                        library = line[:-1].split(',')[0]
                        count = count + 1
                    except StopIteration:
                        print "end of the library list"
                        break

    def _get_exon_file(self):
	config_handle = open(self.config, 'r')
	exon_file = ''
	for linenum, line in enumerate(config_handle):
	    if 'exons =' in line:
		line = line[:-1]
		line_list = line.split('=')
		exon_file = line_list[1]
		break
	return exon_file

    def predict_events(self):
        lib_list_handle = open(self.lib_list, 'r')
        p = '/projects/transabyss/Barnacle/v1.1.0/prediction/predict_events.py'
        BARNACLE_PATH = '/Assembly' + '/' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver
	
	path_pre = self.project_dir + '/'
	
        #ANCHOR_PATH = '/Assembly' + '/' + self.assembly_ver + '/finalize/'
	ANCHOR_PATH = '/Assembly' + '/' + self.assembly_ver + '/anchor/' 
	#library_path_suf = '/Assembly' + '/abyss-' + self.assembly_ver + '/barnacle' + '/ver_' + self.barnacle_ver + '/7_filtered'
        
	library_path_suf = BARNACLE_PATH + '/7_filtered'
	
	count = 0

	exon_file = self._get_exon_file()
	print exon_file


        for linenum, line in enumerate(lib_list_handle):
            library = line[:-1].split(',')[0]
            if (library == self.start_lib):
                count = count + 1
                while ((count < self.lib_num) or (count == self.lib_num)):
                    path = path_pre + library + library_path_suf + '/' + library + '.barnacle.pass'
                    #contig_path = path_pre + library + BARNACLE_PATH + '/1_raw_candidates/' + library + '.barnacle.contigs' 
		    contig_path = path_pre + library + ANCHOR_PATH + library + '-anchor.raw.fa'
		    cmd = 'time /gsc/software/linux-x86_64-centos5/python-2.6.6/bin/python %s %s %s --transcript-annotations %s --use-conflicts --get-breakpoint-exons %s --filter-ITD-repeats --allow-edge-gaps --transcript-sequences %s --contig-sequences %s --pretty' %(p, library, path, self.transcript, exon_file, self.transcript_seq, contig_path)
                    print cmd
                    os.system(cmd)
                    try:
                        line = lib_list_handle.next()
                        library = line[:-1].split(',')[0]
                        count = count + 1
                    except StopIteration:
                        print "end of the library list"
                        break

	
if __name__ == '__main__':

    parser = OptionParser()
    parser.add_option('-i', '--input_file', dest='input_file', help='input file')
    parser.add_option('-p', '--project_dir', dest='project_dir', help='top project directory')
    parser.add_option('-c', '--config_file', dest='config_file', help='configuration file')
    parser.add_option('-H', '--cluster_head', dest='cluster_head', help='cluster_head')
    parser.add_option('-m', '--memory', dest='memory', help='memory request')
    parser.add_option('-s', '--stage', dest='stage', help='stage')
    parser.add_option('-S', '--start_lib', dest='start_lib', help='start_lib')
    parser.add_option('-n', '--lib_num', dest='lib_num', help='number of libraries to be processed')
    parser.add_option('-t', '--transcript', dest='transcript', help='transcript annotation file')
    parser.add_option('-T', '--transcript_seq', dest='transcript_seq', help='transcript sequence file')
    parser.add_option('-r', '--read_length', dest='read_length', help='read length')
    parser.add_option('-N', '--node_name', dest='node_name', help='node name')
    parser.add_option('-q', '--queue', dest='queue', help='queue')
   
    (options, args) = parser.parse_args()
    
    if (options.input_file and options.project_dir and options.config_file and options.cluster_head and options.memory and options.stage and options.start_lib and options.lib_num and options.transcript and options.transcript_seq and options.read_length and options.node_name and options.queue):
        submission = Submission(options.input_file, options.project_dir, options.config_file, options.start_lib, options.lib_num, options.cluster_head, options.memory, options.transcript, options.transcript_seq, options.read_length, options.node_name, options.queue)
	if (options.stage == '0'):
            submission.identify_candidates()
        elif (options.stage == '1'):
	    submission.check_status_cid()
        elif (options.stage == '1.1'):
	    submission.resubmit_cid()
        elif (options.stage == '2'):
	    submission.run_support()
        elif (options.stage == '3'):
	    submission.check_support()
        elif (options.stage == '3.1'):
	    submission.check_p2g_support()
        elif (options.stage == '3.2'):
            submission.resubmit_p2g_support()
        elif (options.stage == '3.3'):
            submission.check_r2c_support()
        elif (options.stage == '3.4'):
            submission.resubmit_r2c_support()
	elif (options.stage == '4'):
	    submission.integrate_p2g()
	elif (options.stage == '5'):
	    submission.integrate_r2c_support()
        elif (options.stage == '6'):
	    submission.filter_groups()
        elif (options.stage == '7'):
	    submission.predict_events()
        else:
            print ('Barnacle v1.1.0' + '\n')
            print ('Usage:' + 'run_barnacle.py\n')
    else:
	print ('\n' + 'Barnacle analysis pipeline v1.1.0' + '\n')
	print ('Usage:') 
	print ('run_barnacle.py [-p project_dir] [-c config_file] [-m memory] [-t transcript] [-T transcript_seq] [-r read_length] [-N node_name] [-q queue] [-H cluster_head] [-S start_library] [-n num_of_library] [-i input] [-s stage<0|1|2|3|4|5|6|7>]' + '\n')
 	print ('Options:')
	print ('-p project_dir')
	print ('   top project directory')
	print ('-c config_file')
	print ('   configuration file for this project')
	print ('-m memory')
	print ('   memory request for cluster jobs')
	print ('-t transcript')
	print ('   transcript annotation file')
	print ('-T transcript_seq')
	print ('   transcript sequence file')
	print ('-r read_length')
	print ('   length of the reads')
	print ('-N node_name')
	print ('-q queue')
	print ('-H cluster_head')
	print ('-S start_library')
	print ('-n num_of_library')
	print ('-i input')
	print ('   input file that specifies library names, Abyss version and Barnacle version')
	print ('-s stage')
	print ('   different stages of the Barnacle analysis pipeline:')
	print ('   0 identifying candidate events')
	print ('   1 checking the completion of step 0')
	print ('   2 grouping, initializing annotation and calculating support')
	print ('   3 checking the completion of step 2')
	print ('   4 integrating the pair-to-genome support')
	print ('   5 integrating the read-to-contig support')
	print ('   6 filtering groups')
	print ('   7 predicting events')
